/*
 ***********************************************************************
 *
 *						    		Life
 *							   Global Database
 *
 * Note, the file declares actual data only if DATABASE_INCLUDE symbol is
 * defined. Otherwise only external references are defined
 *
 ***********************************************************************
 */

#pragma once

#ifdef DATABASE_INCLUDE
#define Declare(Name,Type,Init_value) Type Name = Init_value;
#else
#define Declare(Name,Type,Init_value) extern Type Name;
#endif

Declare(TD_Dimension,short,32)
Declare(Display_scale_factor,short,4)

Declare(TD_animation,char,FALSE)
Declare(TD_animation_period,int,30)

Declare(TD_rotate_with_mouse,char,FALSE)

enum PROJECTION_MODE { DIMETRIC, ISOMETRIC, PROSPECTIVE };
Declare(Projection_mode,enum PROJECTION_MODE,DIMETRIC)

enum PICTURE_TYPE { CUBE, PYRAMID, PYRAMIDS };
Declare(Picture_type,enum PICTURE_TYPE,CUBE)

#undef Declare