/*
 ***********************************************************************
 *
 *					General Initialization and event Handling
 *
 ***********************************************************************
 */

/* MacHeaders Included */
#include <oops.h>
#include "a_menu.h"
#include "a_window.h"
#include "a_dialog.h"

/*
 *----------------------------------------------------------------------
 *							Event Handling
 */

											// Take care of mouseDown events
static void handleMouseDown(EventRecord *theEvent)
{
	WindowPeek	wp;
	short		windowPart = FindWindow (theEvent->where, &wp);
	
    switch (windowPart)
      {
	  case inSysWindow: 
	    SystemClick (theEvent, wp);
	    break;
	    
	  case inMenuBar:
	    (*The_Apple_menu).MenuSelect(MenuSelect(theEvent->where));
	    break;

	  case inContent:
	    if( A_window != (void *)0 && (*A_window).is_our_window((WindowPtr)wp) )
	      (*A_window).click();
	    else
		  SelectWindow(wp);
//	  	if (wp->windowKind == TWINDOWKIND) {
//	  	  if (wp != (WindowPeek) FrontWindow())
//	  	    OBJ(wp)->Select();
//	  	  else
//	  	  	OBJ(wp)->Hit(theEvent->where);
//	  	}
	  	break;
	  	
	  case inDrag:
	    if( A_window != (void *)0 && (*A_window).is_our_window((WindowPtr)wp) )
	      (*A_window).drag(theEvent->where);
	  	  break;
	  	  
	  case inGoAway:
	    if( A_window != (void *)0 && (*A_window).is_our_window((WindowPtr)wp) )
	      (*A_window).close(), A_window = (void *)0;
	  	break;

	  case inGrow:
	    if( A_window != (void *)0 && (*A_window).is_our_window((WindowPtr)wp) )
	      (*A_window).grow(theEvent->where);
	  	break;

#if 0	  	  
	  case inContent:
	  	if (wp->windowKind == TWINDOWKIND) {
	  	  if (wp != (WindowPeek) FrontWindow())
	  	    OBJ(wp)->Select();
	  	  else
	  	  	OBJ(wp)->Hit(theEvent->where);
	  	}
	  	break;
	  	
	  case inZoomIn:
	  case inZoomOut:
	  	if (wp->windowKind == TWINDOWKIND)
	  	  OBJ(wp)->TrackZoom(theEvent->where, windowPart);
#endif
      }
}


extern void HandleEvent(void);

							// The main event dispatcher. This routine should be called
							// repeatedly (it  handles only one event).
void HandleEvent()
{
	short		ok;
	EventRecord	theEvent;

	HiliteMenu(0);
	SystemTask ();						// Handle desk accessories
	(*The_Apple_menu).AdjustAll();
	
	ok = GetNextEvent (everyEvent, &theEvent);
	if( ok )
	  if( Active_dialog != (void *)0 && IsDialogEvent(&theEvent) )
	    (*Active_dialog).handle(&theEvent);
	   else
	    switch (theEvent.what)
	    {
		case mouseDown:
			handleMouseDown(&theEvent);
			break;
			
#if 0			
		case keyDown: 
		case autoKey:
		    if ((theEvent.modifiers & cmdKey) != 0)
			  HandleMenu(MenuKey((char) (theEvent.message & charCodeMask)));
			break;
#endif
			
		case updateEvt:
	    	if( A_window != (void *)0 && (*A_window).is_our_window((WindowPtr)theEvent.message) )
			  A_window->update();
		    break;
		    
		case activateEvt:
	    	if( A_window != (void *)0 && (*A_window).is_our_window((WindowPtr)theEvent.message) )
			  A_window->activate(theEvent.modifiers & 0x01);
			break;
	    }
	  else if( A_window != (void *)0 && A_window->monitor_mouse != (void *)0 )
	      (*A_window).monitor_mouse();
	  else							// No special event, but we still can check time
	    if( A_window != (void *)0 )
	      (*A_window).timeclick();
}


