/*
 ***********************************************************************
 *
 *					 	Various particular sets of points
 *
 *				Set up and draw some particular sets of points
 * Note the drawing functions draw_picture() redefine the default dummy.
 * The function should draw a picture using a particular set of points
 * using line_segments(), color(), etc. functions of class SpacePoints
 *
 ***********************************************************************
 */

#include "Figures.h"

/*
 *----------------------------------------------------------------------
 *								Regular pyramid
 */

Pyramid::Pyramid(void)
{
	allocate(4);
	set_proj_rect(-130,150,150,-130);
	set(1,0,0,0);
	set(2,100,0,0);
	set(3,50,87,0);
	set(4,58,33,74);
	refresh();
}

Pyramid::~Pyramid(void)
{
}

void Pyramid::draw_picture(void)
{
	color(1);
	line_segments(1,2,3,1,4,0);
	line_segments(2,4,0);
	color(2);
	line_segments(3,4,0);	
}

/*
 *----------------------------------------------------------------------
 *							Two	regular pyramids
 */

Pyramids::Pyramids(void)
{
	allocate(8);
	set_proj_rect(-100,140,200,-160);
	set(1,0,0,0);
	set(2,100,0,0);
	set(3,50,87,0);
	set(4,58,33,74);
	set(5,100,150,70);
	set(6,200,150,70);
	set(7,150,237,70);
	set(8,158,183,194);
	refresh();
}

Pyramids::~Pyramids(void)
{
}

void Pyramids::draw_picture(void)
{
	color(1);
	line_segments(1,2,3,1,4,0);
	line_segments(2,4,0);
	line_segments(3,4,0);
	color(2);	
	line_segments(5,6,7,5,8,0);
	line_segments(6,8,0);
	line_segments(7,8,0);	
}


/*
 *----------------------------------------------------------------------
 *									Cube
 */

Cube::Cube(void)
{
	allocate(8);
	set_proj_rect(-380,345,280,-195);
	set(1,0,0,0);
	set(2,200,0,0);
	set(3,200,200,0);
	set(4,0,200,0);
	set(5,0,0,200);
	set(6,200,0,200);
	set(7,200,200,200);
	set(8,0,200,200);
	refresh();
}

Cube::~Cube(void)
{
}

void Cube::draw_picture(void)
{
	color(1);
	line_segments(1,2,3,4,1,5,6,7,8,5,0);
	line_segments(2,6,0);
	line_segments(3,7,0);	
	line_segments(4,8,0);	
}