/*
 ***********************************************************************
 *
 *					 	Stirring Spatial points
 *
 *	Defines the spatial points that can stir, i.e. move, rotate, etc.
 *
 ***********************************************************************
 */

#pragma once				// include this header only once per source file
#include "SpacePoints.h"

class StirringSpacialPoints : public SpacePoints
{
	SpacePoint rotation_axis_p1;			// Those two points specify the rotation
	SpacePoint rotation_axis_p2;			// axis

	float cx, sx, cy, sy;					// Coeffs of the rotation matrices Fx and
											// Fy, see StirringPoints.c for details
	float rotation_angle;					// In radians
											
	void setup_F(void);						// Set up the frame rotation matrix
	
											// Rotate a point over the
											// rotation axis by a given angle
											// (in rads)	
	SpacePoint rotate(const SpacePoint pt, const float angle);
	
public:
	StirringSpacialPoints(void);
	~StirringSpacialPoints(void);

	virtual void click(void);				// Handle a click event
	virtual void timeclick(void);			// Handle a time click
	
											// Set rotation_axis_p1
	void set_rotation_point1(const int x, const int y, const int z);
};
