/*
 ***********************************************************************
 *
 *						    Dialog generic interface
 *
 * The present file provides generic interfaces to the display manager
 * Derived classes should modify some basis functions depending on the
 * specific dialog. 
 *
 ***********************************************************************
 */

#pragma once				// include this header only once per source file

class Dialog : indirect
{
	DialogPtr the_dialog;
	short default_item;				// Item to hit when "Return" is pressed

protected:							// These functions make the life for derived classes easier						
	void open_dialog(const int dialog_resource_no);	// This really creates the dialog
	
public:
	Dialog(void);
	~Dialog(void);
	
	void set_default_item(const short _default_item);
	void handle(const EventRecord * event);		// Handle an event - called only by EventHandler
	virtual void hit(const int item_hit);		// Handle hitting an item
	void select_whole_text(const int item_no);	// Select entire text in the text item
	Str255 * get_text(const int item_no);			// Return the contents of the text item
	void close(void);							// Close the dialog
};

extern Dialog * Active_dialog;
