/*
 ***********************************************************************
 *
 *			    Menu generic object
 *
 * The present file defines a generic menu object that handles common types
 * of the menu processing: initializing, pulling down, deselecting, etc.
 * Any specific actions, if necessary, is to be done by deriving from the
 * present object.
 *
 ***********************************************************************
 */

#pragma once				// include this header only once per source file

#define Max_no_menus 5

extern void A_menu_init(void);		// Packet initialization

class AMenu :  indirect
{
private:
	static short no_menus;			// Handling list of menus
	static AMenu * menus[Max_no_menus];
	
protected:
	MenuHandle	handle;				// Handle of the menu
	virtual void Handle(const short item_no);	// Handle an item
	virtual void Adjust(void);		// Adjust items in the menu

public:
//	AMenu(void);
	~AMenu(void);					// destructor
	void new_menu(Str255 name);	// "Constructor" for  a menu with a given name 

	void MenuSelect(long mSelect);		// Handle the event of menu selection
	void AdjustAll(void);				// Adjust all the items in all the menus

#if 0
	virtual short	Close(void);
			short	GetWindowNumber(void);
	virtual short	Draw(void);
	virtual short	Hit(Point where);
	virtual long	Grow(Point where);
	virtual short	Zoom(short part);
	virtual short	Update(void);
	virtual short	Activate(short active);
	virtual short	Drag(Point where);
	virtual short	Select(void);
	virtual short	Show(void);
	virtual short	Hide(void);
	virtual void	TrackClose(Point where);
	virtual void	TrackZoom(Point where, short part);
	virtual short	IsVisible(void);
	virtual	void	GetWindowTitle (Str255 theTitle);
	virtual	void	SetWindowTitle (Str255 theTitle);
	virtual	void	GetWindowRect(Rect *theRect, Boolean entireWindow);
	virtual	void	RefreshWindow(Boolean entireWindow);
	virtual short	SetFore(long color);
	virtual long	GetFore(void);
	virtual short	SetBack(long color);
	virtual long	GetBack(void);
#endif
};


								// Apple Menu
class AppleMenu : public AMenu
{
public:
	AppleMenu(void);				// Constructor
	~AppleMenu(void);				// Destructor

	virtual void Handle(const short item_no);	// Handle an item
};

extern AppleMenu * The_Apple_menu;
