/*
 ***********************************************************************
 *
 *						    Display manager interface
 *
 * The present file provides interfaces to the display manager who is
 * the only one guy who knows where is our window and what and how to
 * display in it
 *
 ***********************************************************************
 */

#pragma once				// include this header only once per source file

class AWindow : indirect
{
	WindowPtr the_window;
	
public:
	AWindow(void);
	~AWindow(void);
	
											
	void activate(const short go_active);	// Handle an activate or deactivate event
	void update(void);						// Handle an update event
	void close(void);						// Close the window
	virtual void click(void);				// Handle a click event
	int is_our_window(const WindowPtr some_window);	// True if some_window is our
	int is_point_within_the_window(const Point global_point);
	virtual void draw(void);				// Actually draw something
	void display(void);						// Specify what to draw
	virtual void refresh(void);				// Refresh the window
	void select(void);						// Select the window
	virtual void timeclick(void);			// Handle a timeclick
	int (*monitor_mouse)(void);				// If not-nil, points to the procedure to monitor
											// the mouse. Returns 1 if the event has been
											// handled, 0 if the event manager should do it
	void drag(Point	where);					// Drag the window
	void grow(Point	where);					// Grow the window
	
	RgnHandle window_inside_region(void);	// Region that defines the window contents
											// in global coordinates. Don't forget to dispose
											// the handle
};

extern AWindow * A_window;
